
/*//-----------------------------------------------------------------------------
	Niue Development Environment
	Copyright 2008 T. Lansbergen, All Rights Reserved.

	Redistribution and use in source and binary forms, with or without
	modification, are permitted for non-commercial use only.
	
	This software is provided ``as is'' and any express or implied warranties,
	including, but not limited to, the implied warranties of merchantability and
	fitness for a particular purpose are disclaimed. In no event shall
	authors be liable for any direct, indirect, incidental, special,
	exemplary, or consequential damages (including, but not limited to,
	procurement of substitute goods or services; loss of use, data, or profits;
	or business interruption) however caused and on any theory of liability,
	whether in contract, strict liability, or tort (including negligence or
	otherwise) arising in any way out of the use of this software, even if
	advised of the possibility of such damage. 

*///-----------------------------------------------------------------------------


#include "aboutwindow.h"

BRect arect(0,0,260,300);
const rgb_color blue = {0,0,255,0};

aboutwindow::aboutwindow() :
	BWindow(arect, "About Niue", B_TITLED_WINDOW,B_WILL_DRAW | B_NOT_RESIZABLE)
{
	CenterWindow();
		
	//define objects
	vwAbout = new BView(arect, "vwAbout", B_FOLLOW_ALL_SIDES, B_WILL_DRAW | B_PULSE_NEEDED);
	btnClose = new BButton(BRect(10, arect.Height()-30, arect.Width()-10, arect.Height()-10), "btnClose", "Thank you for using Niue", new BMessage(CLOSE_ABOUT_MSG), B_FOLLOW_RIGHT | B_FOLLOW_BOTTOM, B_WILL_DRAW);
	lblAuthor = new BTextView(BRect(10, 60, arect.Width()-10, arect.Height()-60), "lblAuthor", BRect(0,0, arect.Width()-11, arect.Height()-51),B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW);
	txtCredits = new creditbutton(BRect(10,arect.Height()-60,arect.Width()-10,arect.Height()-45), "txtCredits");
	
	AboutBitmap = BTranslationUtils::GetBitmap("about_bmap");
	
	
	//set objects
	lblAuthor->SetText("Version 3 \ncopyright 2008 \nby: Tako Lansbergen (aka 0033)\n\nFeedback:\ntakolansbergen@gmail.com");
	lblAuthor->MakeEditable(false);
	
	//add objects
	AddChild(vwAbout);
	vwAbout->SetViewBitmap(AboutBitmap, B_FOLLOW_TOP | B_FOLLOW_LEFT);
	vwAbout->SetViewColor(255,255,255,0);
	vwAbout->AddChild(btnClose);
	vwAbout->AddChild(lblAuthor);
	vwAbout->AddChild(txtCredits);


}




bool aboutwindow::QuitRequested()
{
	Quit();
}

void aboutwindow::MessageReceived(BMessage* message)
{
	
	switch(message->what)
	{
		case CLOSE_ABOUT_MSG:
		{
			Quit();
		}
		break;
		case SET_ABOUT_TEXT:
		{
			BString string;
			message->FindString("text", &string);
			lblAuthor->SetText(string.String());
			vwAbout->RemoveChild(txtCredits);
			lblAuthor->ResizeBy(0,15);
		}
		break;
	}
}



void aboutwindow::CenterWindow()
{
	
	BScreen mScreen(B_MAIN_SCREEN_ID);
	BRect screenRes, winBounds;
	screenRes.Set((mScreen.Frame().left), (mScreen.Frame().top), (mScreen.Frame().right), (mScreen.Frame().bottom));
	winBounds = Bounds();
	
	MoveBy((screenRes.right / 2) - (winBounds.right / 2), (screenRes.bottom / 2) - (winBounds.bottom / 2));
	
}

creditbutton::creditbutton(BRect rect, const char *name)
				:BView(rect, name, B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW)
{
											
//	SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	
}

void creditbutton::Draw(BRect)
{
	SetHighColor(blue);
	BPoint a,b;
	a.Set(0,Frame().Height()-2);

	DrawString("credits", a);
	
	a.Set(1,Frame().Height()-1);
	b.Set(be_plain_font->StringWidth("credits"),Frame().Height()-1);
	StrokeLine(a,b);
}

void creditbutton::MouseDown(BPoint)
{
	int32			button;
	
//	SetMouseEventMask( B_POINTER_EVENTS, B_LOCK_WINDOW_FOCUS );
	if(Window()->CurrentMessage()->FindInt32("buttons",&button) == B_NO_ERROR)
	{
		if(button & B_PRIMARY_MOUSE_BUTTON)
		{
			BString creditstring;
			creditstring << "Niue would not have been possible without:\n\n";
			creditstring << "Chris Blackbourn, for parts of Yate,\n";
			creditstring << "Robert Polic, for parts of EZLauncher,\n";
			creditstring << "Gabriele Biffi, for parts of File-To-Resource,\n";
			creditstring << "Sylvain Tertois, for parts of his Mover class,\n";
			creditstring << "Rene Gollent, for parts of his IconMenu class,\n";
			creditstring << "Michael Pfeiffer, for parts of his BarberPole class,\n";
			creditstring << "The Haiku project, for keeping me going,\n\n";
			creditstring << "...and everyone I've forgotten here, Thanks!\n";
			
			BMessage msg = SET_ABOUT_TEXT;
			msg.AddString("text", creditstring);
			Window()->PostMessage(&msg);
			
//			(new BAlert("Niue - credits", creditstring.String(), "Close", 0, 0, B_WIDTH_AS_USUAL, B_INFO_ALERT))->Go();
		} 
	}
	
	
}
