
/*//-----------------------------------------------------------------------------
	Niue Development Environment
	Copyright 2008 T. Lansbergen, All Rights Reserved.

	Redistribution and use in source and binary forms, with or without
	modification, are permitted for non-commercial use only.
	
	This software is provided ``as is'' and any express or implied warranties,
	including, but not limited to, the implied warranties of merchantability and
	fitness for a particular purpose are disclaimed. In no event shall
	authors be liable for any direct, indirect, incidental, special,
	exemplary, or consequential damages (including, but not limited to,
	procurement of substitute goods or services; loss of use, data, or profits;
	or business interruption) however caused and on any theory of liability,
	whether in contract, strict liability, or tort (including negligence or
	otherwise) arising in any way out of the use of this software, even if
	advised of the possibility of such damage. 

*///-----------------------------------------------------------------------------




#include "snippetwindow.h"

BRect srect(0,0,350,160);

snippetwindow::snippetwindow() :
	BWindow(srect, "Niue - Add Snippet", B_TITLED_WINDOW,B_WILL_DRAW | B_NOT_RESIZABLE)
{
	CenterWindow();
		
	//define objects
	vwSnippet = new BView(srect, "vwSnippet", B_FOLLOW_ALL_SIDES, B_WILL_DRAW);
	
	btnClose = new BButton(BRect(srect.Width()-200, srect.Height()-30, srect.Width()-110, srect.Height()-10), "btnClose", "Cancel", new BMessage(CANCEL_SNIPPET_MSG), B_FOLLOW_RIGHT | B_FOLLOW_BOTTOM, B_WILL_DRAW | B_NAVIGABLE);
	btnAdd = new BButton(BRect(srect.Width()-100, srect.Height()-30, srect.Width()-10, srect.Height()-10), "btnAdd", "Add", new BMessage(ADD_SNIPPET_MSG), B_FOLLOW_RIGHT | B_FOLLOW_BOTTOM, B_WILL_DRAW | B_NAVIGABLE);
	
	strName = new BStringView(BRect(10,10,srect.Width()-10,25), "strName", "Name:", B_FOLLOW_LEFT | B_FOLLOW_TOP);
	txtName = new BTextControl(BRect(10,30,srect.Width()-10,50), "txtName", 0, "", 0, B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE); 
	
	strCode = new BStringView(BRect(10,60,srect.Width()-10,75), "strCode", "Code:", B_FOLLOW_LEFT | B_FOLLOW_TOP);
	txtCode = new BTextControl(BRect(10,80,srect.Width()-10,95), "txtcode", 0, "", new BMessage(ADD_SNIPPET_MSG), B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE); 
		
	//set objects
	vwSnippet->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
//	btnClose->MakeDefault(true);
	
	//add objects
	AddChild(vwSnippet);
	vwSnippet->AddChild(btnClose);
	vwSnippet->AddChild(btnAdd);
	vwSnippet->AddChild(strName);
	vwSnippet->AddChild(txtName);
	vwSnippet->AddChild(strCode);
	vwSnippet->AddChild(txtCode);
	
	txtName->MakeFocus(true);
}

bool snippetwindow::QuitRequested()
{
	Quit();
}

void snippetwindow::MessageReceived(BMessage* message)
{
	
	switch(message->what)
	{
		case CANCEL_SNIPPET_MSG:
		{
			Quit();
		}
		break;
		
		case ADD_SNIPPET_MSG:
		{
			//for stupid users
			if(strlen(txtName->Text()) < 1 || strlen(txtCode->Text()) < 1)
			{
				(new BAlert("Niue", "Please fill in both fields", "Ok", 0, 0, B_WIDTH_AS_USUAL, B_WARNING_ALERT))->Go();
				break;
			}
			
			//save the snippet
//			BString snippetspath;
			BPath prefspath;
			
			//find prefsfile
			find_directory(B_USER_SETTINGS_DIRECTORY, &prefspath, false);
			prefspath.Append("Niue/niue_snippets");
						
			//create file, override when it already exists
			BFile snippetsfile, rdsnippetsfile;
			snippetsfile.SetTo(prefspath.Path(), B_WRITE_ONLY | B_CREATE_FILE);  //B_OPEN_AT_END-> not were rewriting the whole file
			rdsnippetsfile.SetTo(prefspath.Path(), B_READ_ONLY);
			
			BMessage msg('SNIP');

			msg.AddString(txtName->Text(), txtCode->Text());

			BMessage rdmsg('SNIP');
			rdmsg.Unflatten(&rdsnippetsfile);
			
			if(rdmsg.CountNames(B_STRING_TYPE) > 0)
			{
				int i = 0;
				char		*snipname;
				uint32		type;
				int32		count;
				BString		snipcode;
				
				while(rdmsg.GetInfo(B_STRING_TYPE, i, &snipname, &type, &count) == B_OK)
				{
					if(rdmsg.FindString(snipname, &snipcode) == B_OK)
					{
						msg.AddString(snipname, snipcode);
					}
					i++;
				}
			}			

			
			
			msg.Flatten(&snippetsfile);
			
			//close
			snippetsfile.Unset();
			rdsnippetsfile.Unset();
			
			Quit(); 
		}
		break;
	}
}

void snippetwindow::CenterWindow()
{
	
	BScreen mScreen(B_MAIN_SCREEN_ID);
	BRect screenRes, winBounds;
	screenRes.Set((mScreen.Frame().left), (mScreen.Frame().top), (mScreen.Frame().right), (mScreen.Frame().bottom));
	winBounds = Bounds();
	
	MoveBy((screenRes.right / 2) - (winBounds.right / 2), (screenRes.bottom / 2) - (winBounds.bottom / 2));
	
}
