
/*//-----------------------------------------------------------------------------
	Niue Development Environment
	Copyright 2008 T. Lansbergen, All Rights Reserved.

	Redistribution and use in source and binary forms, with or without
	modification, are permitted for non-commercial use only.
	
	This software is provided ``as is'' and any express or implied warranties,
	including, but not limited to, the implied warranties of merchantability and
	fitness for a particular purpose are disclaimed. In no event shall
	authors be liable for any direct, indirect, incidental, special,
	exemplary, or consequential damages (including, but not limited to,
	procurement of substitute goods or services; loss of use, data, or profits;
	or business interruption) however caused and on any theory of liability,
	whether in contract, strict liability, or tort (including negligence or
	otherwise) arising in any way out of the use of this software, even if
	advised of the possibility of such damage. 

*///-----------------------------------------------------------------------------

#include "velementsview.h"
int y = 0;

velementsview::velementsview(BRect rect, char *name, uint32 resizingMode, uint32 flags)
	   	   : BView(rect, name, resizingMode, flags)
{
	//define objects
	//elements
	BButton* btnBox = new BButton(BRect(5,y+=5,rect.Width()-19,y+=20), "btnBox", "BBox", new BMessage(V_ADD_BOX_MSG), B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP, B_WILL_DRAW);

	BButton* btnButton = new BButton(BRect(5,y+=5,rect.Width()-19,y+=20), "btnButton", "Button", new BMessage(V_ADD_BUTTON_MSG), B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP, B_WILL_DRAW);
	BButton* btnPicButton = new BButton(BRect(5,y+=5,rect.Width()-19,y+=20), "btnPicButton", "Picture Button", new BMessage(V_ADD_PICTUREBUTTON_MSG), B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP, B_WILL_DRAW);

	BButton* btnRadioButton = new BButton(BRect(5,y+=5,rect.Width()-19,y+=20), "btnRadioButton", "Radio Button", new BMessage(V_ADD_RADIOBUTTON_MSG), B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP, B_WILL_DRAW);
	BButton* btnCheckButton = new BButton(BRect(5,y+=5,rect.Width()-19,y+=20), "btnCheckButton", "Check Box", new BMessage(V_ADD_CHECKBOX_MSG), B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP, B_WILL_DRAW);

	BButton* btnStringButton = new BButton(BRect(5,y+=5,rect.Width()-19,y+=20), "btnStringButton", "String View", new BMessage(V_ADD_STRINGVIEW_MSG), B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP, B_WILL_DRAW);
	BButton* btnTextContButton = new BButton(BRect(5,y+=5,rect.Width()-19,y+=20), "btnTextContButton", "Text Control", new BMessage(V_ADD_TEXTCONTROL_MSG), B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP,
	 B_WILL_DRAW);
	BButton* btnTextViewButton = new BButton(BRect(5,y+=5,rect.Width()-19,y+=20), "btnTextViewButton", "Text View", new BMessage(V_ADD_TEXTVIEW_MSG), B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP, B_WILL_DRAW);

	mvrSplit = new Mover(BRect(-1,y+=10,rect.Width()-1,y+=4), B_FOLLOW_LEFT_RIGHT | B_FOLLOW_BOTTOM, false);

	//options
	BRect optionsrect(1,y+1,rect.Width()-B_V_SCROLL_BAR_WIDTH, rect.Height());
	boxOptions = new BBox(optionsrect, "boxOptions", B_FOLLOW_LEFT_RIGHT | B_FOLLOW_BOTTOM, B_WILL_DRAW, B_NO_BORDER);
	chkGrid = new BCheckBox(BRect(15,15,optionsrect.Width()-10, 25), "chkGrid", "Show Grid", new BMessage(V_OPTION_SHOW_GRID), B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP, B_WILL_DRAW);
	chkHandles = new BCheckBox(BRect(15,40,optionsrect.Width()-10, 55), "chkHandles", "Show Handles", new BMessage(V_OPTION_SHOW_HANDLES), B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP, B_WILL_DRAW);
	btnAlignHorz = new BButton(BRect(10,optionsrect.Height()-85,optionsrect.Width()-10,optionsrect.Width()-65), "btnAlignHorz", "Align Horizontally", new BMessage(V_OPTION_ALIGN_HORZ),
	 B_FOLLOW_LEFT_RIGHT | B_FOLLOW_BOTTOM, B_WILL_DRAW);
	btnAlignVert = new BButton(BRect(10,optionsrect.Height()-60,optionsrect.Width()-10,optionsrect.Width()-40), "btnAlignVert", "Align Vertically", new BMessage(V_OPTION_ALIGN_VERT),
	 B_FOLLOW_LEFT_RIGHT | B_FOLLOW_BOTTOM, B_WILL_DRAW);
	btnKillAll = new BButton(BRect(10, optionsrect.Height()-30,optionsrect.Width()-10,optionsrect.Width()-10), "btnKillAll", "Remove All", new BMessage(V_OPTION_KILL_ALL),
	 B_FOLLOW_LEFT_RIGHT | B_FOLLOW_BOTTOM, B_WILL_DRAW);
	

	//view & scroller
	vwAvEls = new BView(BRect(0,0,rect.Width()-B_V_SCROLL_BAR_WIDTH, rect.Height()), "vwAvEls", B_FOLLOW_ALL_SIDES, B_WILL_DRAW | B_FRAME_EVENTS | B_NAVIGABLE);
	scrAvEls = new BScrollView("scrAvEls", vwAvEls, B_FOLLOW_ALL, B_WILL_DRAW, false, true, B_NO_BORDER);
	scrAvEls->ScrollBar(B_VERTICAL)->SetRange(0,0);

	// set objects
	vwAvEls->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	chkGrid->SetValue(1);
	chkHandles->SetValue(1);

	//add objects
	AddChild(scrAvEls); 

	vwAvEls->AddChild(btnBox);
	vwAvEls->AddChild(btnButton);
	vwAvEls->AddChild(btnPicButton);
	vwAvEls->AddChild(btnRadioButton);
	vwAvEls->AddChild(btnCheckButton);
	vwAvEls->AddChild(btnStringButton);
	vwAvEls->AddChild(btnTextContButton);
	vwAvEls->AddChild(btnTextViewButton);
	vwAvEls->AddChild(mvrSplit);
	vwAvEls->AddChild(boxOptions);
	boxOptions->AddChild(chkGrid);
	boxOptions->AddChild(chkHandles);	
	boxOptions->AddChild(btnAlignHorz);
	boxOptions->AddChild(btnAlignVert);
	boxOptions->AddChild(btnKillAll);
}

void velementsview::FrameResized(float width, float height)
{	
		//scroll math
		if(height < y+10)
		{
			scrAvEls->ScrollBar(B_VERTICAL)->SetRange(0,y+10- height);
		}
		else
		{
			scrAvEls->ScrollBar(B_VERTICAL)->SetRange(0,0);
		}
		
}

